#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <Cg/cg.h>
#include <Cg/cgGL.h>
#include "quat.h"
#include "vec.h"
#include "ibitmap.h"

/* tO萔` */
#define FALSE 0
#define TRUE  1

/* EBhETCY */
#define WINDOW_SIZE 512

/* ̉p */
#define FOVY 20.0

/* gbN{[̑ΓIȑ傫 */
#define R 0.8

/* p萔i2̋̕tj */
#define ROOT_2_INV 0.70710678118654752440

/* GLUTj[ʗpԍ */
#define APP_QUIT 1

/* 2}N */
#define SQR(x) ((x) * (x))

/* J[ */
static const GLfloat white[] = { 1.0, 1.0, 1.0, 1.0 };
static const GLfloat blue[]  = { 0.0, 0.0, 1.0, 1.0 };
static const GLfloat black[] = { 0.0, 0.0, 0.0, 1.0 };

/* }EX[Vpϐ */
static int scaling = FALSE;  /* XP[O̕ύX */
static int begin_x, begin_y;  /* }EX̃hbOJnʒu */
static quat curr, last;  /* ]̃NH[^jI */
static GLfloat scale_factor = 1.0;  /* XP[Ol */

/* EBhETCYpϐ */
static int width = WINDOW_SIZE, height = WINDOW_SIZE;

/* _z */
static GLint n_g  = 0;
static GLfloat *g = NULL;
static char *g_fn = NULL;

/* Op`z */
static GLint n_t  = 0;
static GLint *t = NULL;
static char *t_fn = NULL;

/* @z */
static GLfloat n_n = 0;
static GLfloat *n = NULL;

/* ʒu */
#ifdef MACINTOSH
static GLfloat light1[] = { 0.0, 0.0, -10.0, 1.0 };
#else
static GLfloat light1[] = { 0.0, 0.0, 10.0, 1.0 };
#endif

/* _ʒu */
#ifdef MACINTOSH
static GLfloat eye[] = { 0.0, 0.0, -4.0, 1.0 };
#else
static GLfloat eye[] = { 0.0, 0.0, 4.0, 1.0 };
#endif

/* o[ebNXVF[_[ */
static char *v_fn = NULL;

/* tOgVF[_[ */
static char *f_fn = NULL;

/* L[u}bv */
static GLenum c_id = 0;
static GLubyte *c[6] = { NULL, NULL, NULL, NULL, NULL, NULL };
static char *c_fn[6] = { NULL, NULL, NULL, NULL, NULL, NULL };
static GLint c_width[6], c_height[6];

/* Cgpp^ */
static CGcontext cg_context;
static CGprofile vp_profile, fp_profile;
static CGprogram vertex_shader, fragment_shader;
static CGparameter model_view_proj_matrix, model_view_matrix, model_view_matrix_2;
static CGparameter eye_position, light_position;
static CGparameter k_specular, k_diffuse, k_ambient, shininess;
static CGparameter cubemap;

/* CgG[`FbN */
static void check_cg_error(void)
{
	CGerror err = cgGetError();
	if (err != CG_NO_ERROR) {
		fprintf(stderr, "cg error: %s\n", cgGetErrorString(err));
		exit(1);
	}
}

/* aR̋ւ̓e */
static GLfloat project_to_sphere(GLfloat x, GLfloat y)
{
	GLfloat z;
	GLfloat d_sqr, d;
	
	d_sqr = SQR(x) + SQR(y);
	d = sqrt(d_sqr);  /* d(x,y)̌_̋ */
	if (d < R) {  /* (x,y)aR̉~ł */
		z = sqrt(2.0 * SQR(R) - d_sqr);
		  /* aR̉~ɊOڂ鐳`ڂ鋅ɓe */
	}
	else {  /* (x,y)aR̉~łȂ */
		z = SQR(R) / d;  /* ȉ~̂ɓe */
	}
	return z;
}

/* gbN{[̃V~[V */
static void simulate_trackball(quat *q, GLfloat p1x,
  GLfloat p1y, GLfloat p2x, GLfloat p2y)
{
	if (p1x == p2x && p1y == p2y) { 
		/* }EẌړʂ[Ȃ */
		quat_identity(q);
		  /* ACfeBeBNH[^jIԂ */
	}
	else {
		/* }EẌړʂ[łȂȂ */
		quat p1, p2, a, d;
		float p1z, p2z;
		float s, t;
		
		/* xNgp1FgbN{[ړJnʒu */
		p1z = project_to_sphere(p1x, p1y);
		quat_assign(&p1, 0.0, p1x, p1y, p1z);
		
		/* xNgp2: gbN{[ړIʒu */
		p2z = project_to_sphere(p2x, p2y);
		quat_assign(&p2, 0.0, p2x, p2y, p2z);
		
		/* gbN{[̉]߂ */
		quat_mul(&a, &p1, &p2);
		  /* xNgp2ƃxNgp1̊OςxNgaƂ */
		
		/* xNgaPʃxNgɂ */
		a.w = 0.0;
		s = quat_norm(&a);
		quat_div_real(&a, &a, s);
		
		/* gbN{[̉]ʂ߂ */
		quat_sub(&d, &p1, &p2);
		  /* xNgp1ƃxNgp2̍xNgdƂ */
		
		/* xNgd̃m */
		t = quat_norm(&d) / (2.0 * R * ROOT_2_INV);
		/* m1傫ȂĂ܂1ɂ */
		if (t > 1.0) t = 1.0;
		
		/*
		 * ]̃NH[^jI̐ݒ
		 *
		 * {͉]̃NH[^jI
		 *
		 *   theta = 2.0 * asin(t);
		 *   q->w = cos(phi / 2.0);
		 *   q->x = a.x * sin(theta / 2.0);
		 *   q->y = a.y * sin(theta / 2.0);
		 *   q->z = a.z * sin(theta / 2.0);
		 *
		 * ƌvZƂ낾CtgقvZ
		 *
		 */
		quat_assign(q, cos(asin(t)), a.x * t, a.y * t, a.z * t);
	}
}

/* NH[^jI]s */
static void create_rotation_matrix(GLfloat m[4][4],
	const quat *q)
{
	m[0][0] = 1.0 - 2.0 * (q->y * q->y + q->z * q->z);
	m[0][1] =       2.0 * (q->x * q->y - q->z * q->w);
	m[0][2] =       2.0 * (q->z * q->x + q->w * q->y);
	m[0][3] = 0.0;
	m[1][0] =       2.0 * (q->x * q->y + q->z * q->w);
	m[1][1] = 1.0 - 2.0 * (q->z * q->z + q->x * q->x);
	m[1][2] =       2.0 * (q->y * q->z - q->w * q->x);
	m[1][3] = 0.0;
	m[2][0] =       2.0 * (q->z * q->x - q->w * q->y);
	m[2][1] =       2.0 * (q->y * q->z + q->x * q->w);
	m[2][2] = 1.0 - 2.0 * (q->y * q->y + q->x * q->x);
	m[2][3] = 0.0;
	m[3][0] = 0.0;
	m[3][1] = 0.0;
	m[3][2] = 0.0;
	m[3][3] = 1.0;
}

/* ̂` */
static void draw_object(void)
{
	/* VF[_[N */
	if (v_fn) {
		cgGLEnableProfile(vp_profile);
		cgGLBindProgram(vertex_shader);
		if (f_fn) {
			cgGLEnableProfile(fp_profile);
			cgGLBindProgram(fragment_shader);
		}
		cgGLSetParameter1f(k_specular, 1.0);
		cgGLSetParameter1f(k_diffuse, 0.6);
		cgGLSetParameter1f(k_ambient, 0.1);
		cgGLSetParameter1f(shininess, 5.0);
		cgGLSetParameter4fv(light_position, light1);
		cgGLSetParameter4fv(eye_position, eye);
		cgGLSetStateMatrixParameter(model_view_proj_matrix,
				CG_GL_MODELVIEW_PROJECTION_MATRIX, CG_GL_MATRIX_IDENTITY);
		cgGLSetStateMatrixParameter(model_view_matrix,
				CG_GL_MODELVIEW_MATRIX, CG_GL_MATRIX_IDENTITY);
		if (f_fn) {
			cgGLSetStateMatrixParameter(model_view_matrix_2,
					CG_GL_MODELVIEW_MATRIX, CG_GL_MATRIX_IDENTITY);
			cgGLSetTextureParameter(cubemap, c_id);
			cgGLEnableTextureParameter(cubemap);
		}
	}
	/* WIgȂ && 摜Ȃ */
	if (!g) {
		/* g[X` */
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, white);
		glutSolidTorus(0.25, 0.5, 8, 8);
	}
	/* WIg񂠂 && g|W񂠂 && @񂠂 */
	else if (g && t && n) {
		/* T[tFX_O */
		int i, j;
		
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, white);
		glBegin(GL_TRIANGLES);
		for (i = 0; i < n_t / 4; ++i) {
			for (j = 0; j < 3; ++j) {
				glNormal3fv(n + t[i * 4 + j] * 4);
				glVertex3fv(g + t[i * 4 + j] * 4);
			}
		}
		glEnd();
		if (c_id != 0) {
			glDisable(GL_TEXTURE_CUBE_MAP);
		}
	}
	/* WIg񂠂 && g|WȂ */
	else if (g && !t) {
		/* |Cg_O */
		int i;
		
		glDisable(GL_LIGHTING);
		glColor4f(1.0, 1.0, 1.0, 1.0);
		glBegin(GL_POINTS);
		for (i = 0; i < n_g / 4; ++i) {
			glVertex4fv(g + i * 4);
		}
		glEnd();
		glEnable(GL_LIGHTING);
	}
	if (v_fn) {
		cgGLDisableProfile(vp_profile);
		if (f_fn) {
			cgGLDisableProfile(fp_profile);
		}
	}
}

/* GLUT`R[obN֐ */
static void draw(void)
{
	draw_object();
}

/* GLUTfBXvCR[obN֐ */
static void display_func(void)
{
#ifdef MACINTOSH
	static GLfloat v[4][4] = {
		{ 1.0, 0.0, 0.0, 0.0 },
		{ 0.0, 1.0, 0.0, 0.0 },
		{ 0.0, 0.0, -1.0, 0.0 },
		{ 0.0, 0.0, 0.0, 1.0 } };
#else
	static GLfloat v[4][4] = {
		{ 1.0, 0.0, 0.0, 0.0 },
		{ 0.0, 1.0, 0.0, 0.0 },
		{ 0.0, 0.0, 1.0, 0.0 },
		{ 0.0, 0.0, -4.0, 1.0 } };
#endif
	 
	GLfloat m[4][4];  /* W̉]s */
	int i, j;
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		/* ʃNA */
	glLoadIdentity();  /* PʍsZbg */
	glMultMatrixf(&v[0][0]);  /* _ʒuZbg */
	glPushMatrix();
	create_rotation_matrix(m, &curr);
	/* NH[^jI]s𐶐 */
	glScalef(scale_factor, scale_factor, scale_factor);
	/* XP[O */
	glMultMatrixf(&m[0][0]);  /* ]sZbg */
	draw();  /* `悷 */
	glPopMatrix();
	glutSwapBuffers();  /* `obt@̓ւ */
}

/* GLUTVFCvR[obN֐ */
static void reshape_func(int w, int h)
{
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
		/* EBhETCYw */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
		/* vWFNVsɒPʍsZbg */
	gluPerspective(FOVY, (GLfloat)w/(GLfloat)h, 1.0, -100.0);
	  /* p[XyNeBuϊsZbg */
	glMatrixMode(GL_MODELVIEW);
	width = w;
	height = h;
}

/* Applicationj[֐ */
static void app_menu_func(int menu)
{
	switch (menu) {
	case APP_QUIT:
		exit(0);  /* APP_QUITj[ŃvOI */
		break;
	default:
		break;
	}
}

/* GLUTj[R[obN֐ */
static void menu_func(int dummy0)
{
	/* Ȃ */
	return;
}

/* GLUTL[{[hR[obN֐ */
static void keyboard_func(unsigned char key,
	int dummy1, int dummy2)
{
	switch (key) {
		case 'q':
		case 'Q':
		app_menu_func(APP_QUIT);
		  /* QL[ꂽAPP_QUITj[I񂾂̂Ɠ */
		break;
	default:
		break;
	}
}

/* GLUT}EXR[obN֐ */
static void mouse(int button, int state, int x, int y)
{
	if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
		/* {^hbOJn */
		begin_x = x;
		begin_y = y;
		if (glutGetModifiers() & GLUT_ACTIVE_SHIFT) { 
			/* SHIFTL[ */
			scaling = TRUE;  /* XP[OύX */
		}
		else {  /* SHIFTL[Ȃ */
			scaling = FALSE;  /* _ύX */
		}
	}
}

/* GLUT}EX[VR[obN֐ */
static void motion(int x, int y)
{
	static int count = 0;  /* ̊֐Ă΂ꂽ */
	
	if (scaling) {  /* XP[OύXȂ */
		scale_factor = scale_factor
			* (1.0 + (((float) (begin_y - y)) / height));
		begin_x = x;
		begin_y = y;
		glutPostRedisplay();  /* ĕ` */
		return;
	}
	else {
		quat t;
		
		simulate_trackball(&last, (2.0 * begin_x - width) / width,
			(height - 2.0 * begin_y) / height,
			(2.0 * x - width) / width,
			(height - 2.0 * y) / height);
			/* 
			 * EBhES0CEBhE2ɒ
			 * }EXʒusimulate_trackballɂ킽
			 * 
			 */
		begin_x = x;
		begin_y = y;
		
		/* lastcurr̃NH[^jIςcurrɑ */
		quat_mul(&t, &last, &curr);
		curr = t;
		
		if (++count % 97 == 0) {  /* ̊֐971̊... */
			GLfloat n;
			
			/* NH[^jIcurr𐳋K */
			n = quat_norm(&curr);
			quat_div_real(&curr, &curr, n);
		}
		glutPostRedisplay();  /* ĕ` */
	}
}

/* GLUTj[̏ */
static void init_glut_menu(void)
{
	int app_menu;
	
	/* Applicationj[o^ */
	app_menu = glutCreateMenu(app_menu_func);
	glutAddMenuEntry("Quit (Q)", APP_QUIT);
	
	/* j[o^ */
	glutCreateMenu(menu_func);
	glutAddSubMenu("Application", app_menu);
	
	/* j[}EXE{^ɃA^b` */
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}

/* GLUT̏ */
static void init_glut(int *argc, char **argv)
{
	glutInit(argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);  /* RGBAC_uobt@CfvXobt@w */
	glutInitWindowSize(WINDOW_SIZE, WINDOW_SIZE);  /* EBhETCYw */
	glutInitWindowPosition(100, 100);  /* EBhEʒuw */
	glutCreateWindow(argv[0]);  /* EBhE𐶐 */
	glutKeyboardFunc(keyboard_func);  /* L[{[hR[obN֐w */
	glutDisplayFunc(display_func);  /* fBXvCR[obN֐w */
	glutReshapeFunc(reshape_func);  /* VFCvR[obN֐w */
	glutMouseFunc(mouse);  /* }EXR[obN֐w */
	glutMotionFunc(motion);  /* }EXړR[obN֐w */
	glutSetCursor(GLUT_CURSOR_RIGHT_ARROW);  /* }EXJ[\w */
	init_glut_menu();  /* j[ */
}

/* OpenGL̏ */
static void init_gl(void)
{
	glClearColor(101.0 / 255.0, 113.0 / 255.0, 133.0 / 255.0, 1.0);  /* wiF̐ݒ */
	glEnable(GL_DEPTH_TEST);  /* fvXeXgL */
	glEnable(GL_NORMALIZE);  /* @xNg̎KL */
	glEnable(GL_LIGHTING);  /* CeBOL */
	/* ArGg */
	glLightfv(GL_LIGHT0, GL_DIFFUSE, black);  /* ftHg̃fBt[YItɂĂ */
	glEnable(GL_LIGHT0);
	/* FfBt[Y */
	glLightfv(GL_LIGHT1, GL_DIFFUSE, white);
	glLightfv(GL_LIGHT1, GL_POSITION, light1);
	glEnable(GL_LIGHT1);
	simulate_trackball(&curr, 0.0, 0.0, 0.0, 0.0);  /* currNH[^jI */
}

/* main֐ */
int main(int argc, char **argv) {
	init_glut(&argc, argv);
	init_gl();
	
	/* R}hC̉ */
	while (--argc) {
		++argv;
		if (**argv == '-') {
			++*argv;
			switch (**argv) {
			  case 'g':
				/* WIgw */
				g_fn = ++*argv;
				break;
			  case 't':
				/* g|Ww */
				t_fn = ++*argv;
				break;
			  case 'v':
				/* o[ebNXVF[_[w */
				v_fn = ++*argv;
				break;
			  case 'f':
				/* tOgVF[_[w */
				f_fn = ++*argv;
				break;
			  case 'X':
				c_fn[0] = ++*argv;
				break;
			  case 'x':
				c_fn[1] = ++*argv;
				break;
			  case 'Y':
				c_fn[2] = ++*argv;
				break;
			  case 'y':
				c_fn[3] = ++*argv;
				break;
			  case 'Z':
				c_fn[4] = ++*argv;
				break;
			  case 'z':
				c_fn[5] = ++*argv;
				break;
			  default:
				break;
			}
		}
	}
	/* WIg̓ǂݍ */
	if (g_fn) {
		FILE *g_f = fopen(g_fn, "r");
		if (g_f) {
			fgetfv(&n_g, &g, g_f);
			fclose(g_f);
		}
	}
	/* g|W̓ǂݍ */
	if (t_fn) {
		FILE *t_f = fopen(t_fn, "r");
		if (t_f) {
			fgetiv(&n_t, &t, t_f);
			fclose(t_f);
		}
	}
	/* o[ebNXVF[_[̓ǂݍ */
	if (v_fn) {
		if (cgGLIsProfileSupported(CG_PROFILE_ARBVP1)) {
			vp_profile = CG_PROFILE_ARBVP1;
		}
		else {
			fprintf(stderr, "arbvp1 not supported.\n");
			exit(1);
		}
		cg_context = cgCreateContext();
		check_cg_error();
		vertex_shader = cgCreateProgramFromFile(cg_context, CG_SOURCE, v_fn, 
				vp_profile, NULL, NULL);
		check_cg_error();
		
		cgGLLoadProgram(vertex_shader);
		check_cg_error();
		
		model_view_proj_matrix = cgGetNamedParameter(vertex_shader, "model_view_proj_matrix");
		model_view_matrix = cgGetNamedParameter(vertex_shader, "model_view_matrix");
		eye_position = cgGetNamedParameter(vertex_shader, "eye_position");
		light_position = cgGetNamedParameter(vertex_shader, "light_position");
		shininess = cgGetNamedParameter(vertex_shader, "shininess");
		k_specular = cgGetNamedParameter(vertex_shader, "k_specular");
		k_diffuse = cgGetNamedParameter(vertex_shader, "k_diffuse");
		k_ambient = cgGetNamedParameter(vertex_shader, "k_ambient");
		
		/* tOgVF[_[̓ǂݍ */
		if (f_fn) {
			if (cgGLIsProfileSupported(CG_PROFILE_ARBFP1)) {
				fp_profile = CG_PROFILE_ARBFP1;
			}
			else {
				fprintf(stderr, "arbfp1 not supported.\n");
				exit(1);
			}
			fragment_shader = cgCreateProgramFromFile(cg_context, CG_SOURCE, f_fn,
					fp_profile, NULL, NULL);
			check_cg_error();
			
			cgGLLoadProgram(fragment_shader);
			check_cg_error();
			
			model_view_matrix_2 = cgGetNamedParameter(fragment_shader, "model_view_matrix");
			cubemap = cgGetNamedParameter(fragment_shader, "cubemap");
			
			/* I */
			eye_position = cgGetNamedParameter(fragment_shader, "eye_position");
			light_position = cgGetNamedParameter(fragment_shader, "light_position");
			shininess = cgGetNamedParameter(fragment_shader, "shininess");
			k_specular = cgGetNamedParameter(fragment_shader, "k_specular");
			k_diffuse = cgGetNamedParameter(fragment_shader, "k_diffuse");
			k_ambient = cgGetNamedParameter(fragment_shader, "k_ambient");
		}
	}
	
	/* L[u}bv摜̓ǂݍ */
	if (c_fn[0] && c_fn[1] && c_fn[2] && c_fn[3] && c_fn[4] && c_fn[5]) {
		IBITMAP *bm[6];
		int i;
		
		for (i = 0; i < 6; ++i) {
			fprintf(stderr, "loading %s... ", c_fn[i]);
			bm[i] = malloc(sizeof(IBITMAP));
			load_bitmap(bm[i], c_fn[i]);
			c[i] = (GLubyte*)bm[i]->pixels;
			c_width[i] = bm[i]->width;
			c_height[i] = bm[i]->height;
			fprintf(stderr, "loaded %d x %d image\n", c_width[i], c_height[i]);
		}
		glGenTextures(1, &c_id);
		glBindTexture(GL_TEXTURE_CUBE_MAP, c_id);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_X, 0, GL_RGB8, c_width[0], c_height[0], 0, GL_RGB,
				GL_UNSIGNED_BYTE, c[0]);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_X, 0, GL_RGB8, c_width[1], c_height[1], 0, GL_RGB,
				GL_UNSIGNED_BYTE, c[1]);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_Y, 0, GL_RGB8, c_width[2], c_height[2], 0, GL_RGB,
				GL_UNSIGNED_BYTE, c[2]);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_Y, 0, GL_RGB8, c_width[3], c_height[3], 0, GL_RGB,
				GL_UNSIGNED_BYTE, c[3]);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_Z, 0, GL_RGB8, c_width[4], c_height[4], 0, GL_RGB,
				GL_UNSIGNED_BYTE, c[4]);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_Z, 0, GL_RGB8, c_width[5], c_height[5], 0, GL_RGB,
				GL_UNSIGNED_BYTE, c[5]);
		glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP);  /* 摜Ë̎w */
		glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_R, GL_CLAMP);
		glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);  /* 摜tB^̎w */
		glTexParameterf(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_CUBE_MAP, 0);
	}
	
	/* WIgƃg|W񂪗^ꂽꍇ@ */
	if (g && t) {
		int i, j, k;
		
		n_n = n_g;  /* @xNǧi_Ɠj */
		n = calloc(n_n, sizeof(GLfloat));
		for (i = 0; i < n_t / 4; ++i) {
			GLfloat nn, an[3], av[3][3];
			GLint tt[3];
			
			/* Op`Ƃɖ@xNgvZ */
			for (j = 0; j < 3; ++j) {
				tt[j] = t[i * 4 + j];
				for (k = 0; k < 3; ++k) {
					av[j][k] = g[tt[j] * 4 + k];
				}
			}
			for (j = 1; j < 3; ++j) {
				for (k = 0; k < 3; ++k) {
					av[j][k] -= av[0][k];
				}
			}
			an[0] = av[1][1] * av[2][2] - av[1][2] * av[2][1];
			an[1] = av[1][2] * av[2][0] - av[1][0] * av[2][2];
			an[2] = av[1][0] * av[2][1] - av[1][1] * av[2][0];
			nn = sqrt(an[0] * an[0] + an[1] * an[1] + an[2] * an[2]);
			for (k = 0; k < 3; ++k) {
				an[k] /= nn;
			}
			/* ЂƂ̒_̎Op`ɋLĂ邱Ƃ̂łׂĂ̎Op`̊^𑫂킹 */
			for (j = 0; j < 3; ++j) {
				for (k = 0; k < 3; ++k) {
					n[tt[j] * 4 + k] += an[k];
				} 
				n[tt[j] * 4 + 3] += 1.0;
			}
		}
		/* ̎Op`̊^𕽋ω */
		for (i = 0; i < n_n / 4; ++i) {
			for (j = 0; j < 3; ++j) {
				n[i * 4 + j] /= n[i * 4 + 3];
			}
		}
	}
	
	glutMainLoop();
	return 0;
}
