#include <GL/glut.h>

#define WINDOW_SIZE 512
#define FOVY 20.0

static const GLfloat white[] = { 1.0, 1.0, 1.0, 1.0 };
static const GLfloat gray[] = { 0.1, 0.1, 0.1, 1.0 };
static const GLfloat black[] = { 0.0, 0.0, 0.0, 1.0 };

#ifdef MACINTOSH
static GLfloat light1[] ={ 0.0, 0.0, -10.0, 1.0 };
#else
static GLfloat light1[] ={ 0.0, 0.0, 10.0, 1.0 };
#endif

static int width = WINDOW_SIZE, height = WINDOW_SIZE;

static void draw(void)
{
	glutSolidTorus(0.25, 0.5, 8, 8);
}

static void display(void)
{
	static GLfloat v[4][4] = {
		{ 1.0, 0.0, 0.0, 0.0 },
				{ 0.0, 1.0, 0.0, 0.0 },
				{ 0.0, 0.0, -1.0, 0.0 },
			{ 0.0, 0.0, 0.0, 1.0 } };
					
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
#ifdef MACINTOSH
	glLoadMatrixf(&v[0][0]); 
#else
	glLoadIdentity();
	gluLookAt(0.0, 0.0, 4.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
#endif
	draw();
	glutSwapBuffers();
}

static void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(FOVY, (GLfloat)w / (GLfloat)h, 2.0, -2.0);
	glMatrixMode(GL_MODELVIEW);
	width = w;  height = h;
}

int main(int argc, char **argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
	glutInitWindowSize(WINDOW_SIZE, WINDOW_SIZE);
	glutInitWindowPosition(100, 100);
	glutCreateWindow(argv[0]);
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	glEnable(GL_LIGHTING);
	
	glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
	glLightfv(GL_LIGHT0, GL_AMBIENT, gray);
	glEnable(GL_LIGHT0);
	
	glLightfv(GL_LIGHT1, GL_DIFFUSE, white);
	glLightfv(GL_LIGHT1, GL_POSITION, light1);
	glEnable(GL_LIGHT1);
	
	glutMainLoop();
	return 0;
}