/*
 * VectorStream 1.4
 * Copyright (c) 2002, Ichiroh Kanaya
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * $Id: vec.h,v 1.2 2003/07/08 09:43:36 kanaya Exp $
 *
 */

#ifndef __VEC_H
#define __VEC_H

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

  extern void fputheader(FILE *fout);
  extern void fputm(const char *comment, FILE *fout);

  extern void fputfv(int n, const float *p, int r, FILE *fout);
  extern void fgetfv(int *n, float **p, FILE *fin);

  extern void fputiv(int n, const int *p, int r, FILE *fout);
  extern void fgetiv(int *n, int **p, FILE *fin);

  extern void fputhv(int n, const short *p, int r, FILE *fout);
  extern void fgethv(int *n, short **p, FILE *fin);

#ifdef __cplusplus
}
#endif

#endif
