#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include "quat.h"
#include "vec.h"

/* tO萔` */
#define FALSE 0
#define TRUE  1

/* EBhETCY */
#define WINDOW_SIZE 512

/* ̉p */
#define FOVY 20.0

/* gbN{[̑ΓIȑ傫 */
#define R 0.8

/* p萔i2̋̕tj */
#define ROOT_2_INV 0.70710678118654752440

/* GLUTj[ʗpԍ */
#define APP_QUIT 1

/* 2}N */
#define SQR(x) ((x) * (x))

/* J[ */
static const GLfloat white[] = { 1.0, 1.0, 1.0, 1.0 };
static const GLfloat blue[]  = { 0.0, 0.0, 1.0, 1.0 };
static const GLfloat black[] = { 0.0, 0.0, 0.0, 1.0 };

/* }EX[Vpϐ */
static int scaling = FALSE;  /* XP[O̕ύX */
static int begin_x, begin_y;  /* }EX̃hbOJnʒu */
static quat curr, last;  /* ]̃NH[^jI */
static GLfloat scale_factor = 1.0;  /* XP[Ol */

/* EBhETCYpϐ */
static int width = WINDOW_SIZE, height = WINDOW_SIZE;

/* _z */
static GLint n_g  = 0;
static GLfloat *g = NULL;
static char *g_fn = NULL;

/* Op`z */
static GLint n_t  = 0;
static GLint *t = NULL;
static char *t_fn = NULL;

/* 摜 */
static GLint n_e = 0;
static GLint n_e_x = 0;
static GLint n_e_y = 0;
static GLubyte *e = NULL;
static char *e_fn = NULL;

/* @z */
static GLfloat n_n = 0;
static GLfloat *n = NULL;

/* 摜t@C̓ǂݍ */
static GLubyte *load_image(FILE *fin)
{
	GLubyte *image;
	char buff[255];
	char head;
	
	/* wb_̓ǂݔ΂ */
	fgets(buff, 255, fin);
	/* Rg̓ǂݔ΂ */
	do {
		fgets(buff, 255, fin);
	}
	while (buff[0] == '#');
	/* 摜TCY̓ǂݏo */
	sscanf(buff, "%d %d", &n_e_x, &n_e_y);
	n_e = n_e_x * n_e_y * 3;
	/* J[[xǂݔ΂ */
	fgets(buff, 255, fin);
	/* 摜ǂݏo */
	image = calloc(n_e, sizeof(GLubyte));
	fread(image, sizeof(GLubyte), n_e, fin);
	
	return image;
}

/* aR̋ւ̓e */
static GLfloat project_to_sphere(GLfloat x, GLfloat y)
{
	GLfloat z;
	GLfloat d_sqr, d;
	
	d_sqr = SQR(x) + SQR(y);
	d = sqrt(d_sqr);  /* d(x,y)̌_̋ */
	if (d < R) {  /* (x,y)aR̉~ł */
		z = sqrt(2.0 * SQR(R) - d_sqr);
		  /* aR̉~ɊOڂ鐳`ڂ鋅ɓe */
	}
	else {  /* (x,y)aR̉~łȂ */
		z = SQR(R) / d;  /* ȉ~̂ɓe */
	}
	return z;
}

/* gbN{[̃V~[V */
static void simulate_trackball(quat *q, GLfloat p1x,
  GLfloat p1y, GLfloat p2x, GLfloat p2y)
{
	if (p1x == p2x && p1y == p2y) { 
		/* }EẌړʂ[Ȃ */
		quat_identity(q);
		  /* ACfeBeBNH[^jIԂ */
	}
	else {
		/* }EẌړʂ[łȂȂ */
		quat p1, p2, a, d;
		float p1z, p2z;
		float s, t;
		
		/* xNgp1FgbN{[ړJnʒu */
		p1z = project_to_sphere(p1x, p1y);
		quat_assign(&p1, 0.0, p1x, p1y, p1z);
		
		/* xNgp2: gbN{[ړIʒu */
		p2z = project_to_sphere(p2x, p2y);
		quat_assign(&p2, 0.0, p2x, p2y, p2z);
		
		/* gbN{[̉]߂ */
		quat_mul(&a, &p1, &p2);
		  /* xNgp2ƃxNgp1̊OςxNgaƂ */
		
		/* xNgaPʃxNgɂ */
		a.w = 0.0;
		s = quat_norm(&a);
		quat_div_real(&a, &a, s);
		
		/* gbN{[̉]ʂ߂ */
		quat_sub(&d, &p1, &p2);
		  /* xNgp1ƃxNgp2̍xNgdƂ */
		
		/* xNgd̃m */
		t = quat_norm(&d) / (2.0 * R * ROOT_2_INV);
		/* m1傫ȂĂ܂1ɂ */
		if (t > 1.0) t = 1.0;
		
		/*
		 * ]̃NH[^jI̐ݒ
		 *
		 * {͉]̃NH[^jI
		 *
		 *   theta = 2.0 * asin(t);
		 *   q->w = cos(phi / 2.0);
		 *   q->x = a.x * sin(theta / 2.0);
		 *   q->y = a.y * sin(theta / 2.0);
		 *   q->z = a.z * sin(theta / 2.0);
		 *
		 * ƌvZƂ낾CtgقvZ
		 *
		 */
		quat_assign(q, cos(asin(t)), a.x * t, a.y * t, a.z * t);
	}
}

/* NH[^jI]s */
static void create_rotation_matrix(GLfloat m[4][4],
	const quat *q)
{
	m[0][0] = 1.0 - 2.0 * (q->y * q->y + q->z * q->z);
	m[0][1] =       2.0 * (q->x * q->y - q->z * q->w);
	m[0][2] =       2.0 * (q->z * q->x + q->w * q->y);
	m[0][3] = 0.0;
	m[1][0] =       2.0 * (q->x * q->y + q->z * q->w);
	m[1][1] = 1.0 - 2.0 * (q->z * q->z + q->x * q->x);
	m[1][2] =       2.0 * (q->y * q->z - q->w * q->x);
	m[1][3] = 0.0;
	m[2][0] =       2.0 * (q->z * q->x - q->w * q->y);
	m[2][1] =       2.0 * (q->y * q->z + q->x * q->w);
	m[2][2] = 1.0 - 2.0 * (q->y * q->y + q->x * q->x);
	m[2][3] = 0.0;
	m[3][0] = 0.0;
	m[3][1] = 0.0;
	m[3][2] = 0.0;
	m[3][3] = 1.0;
}

/* t[` */
#define L 0.5
static void draw_frame(void)
{
	/* ̂̒_ʒuƕӂ̃f[^ */
	static GLfloat vdata[8][3] = {
		{ -L, -L, -L }, { L, -L, -L }, { L, L, -L }, { -L, L, -L },
		{ -L, -L, L }, { L, -L, L }, { L, L, L }, { -L, L, L } };
	static GLint tindices[6][4] = {
		{ 0, 1, 2, 3 }, { 0, 1, 5, 4 }, { 3, 0, 4, 7 },
		{ 1, 2, 6, 5 }, { 2, 3, 7, 6 },{ 5, 4, 7, 6 } };
	int i;
	
	/* 3ʂ` */
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, blue);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, black);
	for (i = 0; i < 3; ++i) {
		glBegin(GL_QUADS);
			glNormal3fv(&vdata[tindices[i][0]][0]);
			glVertex3fv(&vdata[tindices[i][0]][0]);
			glNormal3fv(&vdata[tindices[i][1]][0]);
			glVertex3fv(&vdata[tindices[i][1]][0]);
			glNormal3fv(&vdata[tindices[i][2]][0]);
			glVertex3fv(&vdata[tindices[i][2]][0]);
			glNormal3fv(&vdata[tindices[i][3]][0]);
			glVertex3fv(&vdata[tindices[i][3]][0]);
		glEnd();
	}
}

/* ̂` */
static void draw_object(void)
{
	/* WIgȂ && 摜Ȃ */
	if (!g && !e) {
		/* eB[|bg` */
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, white);
		glutSolidTeapot(0.3);
	}
	/* WIgȂ && 摜 */
	else if (!g && e) {
		/* }bsOꂽeB[|bg` */
		glDisable(GL_LIGHTING);
		glEnable(GL_TEXTURE_2D);
		glutSolidTeapot(0.3);
		glDisable(GL_TEXTURE_2D);
		glEnable(GL_LIGHTING);
	}
	/* WIg񂠂 && g|W񂠂 && @񂠂 && 摜 */
	else if (g && t && n && e) {
		/* T[tFX_O{}bsO */
		int i, j;
		
		glDisable(GL_LIGHTING);
		glEnable(GL_TEXTURE_2D);
		glBegin(GL_TRIANGLES);
		for (i = 0; i < n_t / 4; ++i) {
			for (j = 0; j < 3; ++j) {
				glNormal3fv(n + t[i * 4 + j] * 4);
				glVertex3fv(g + t[i * 4 + j] * 4);
			}
		}
		glEnd();
		glDisable(GL_TEXTURE_2D);
		glEnable(GL_LIGHTING);
	}
	/* WIg񂠂 && g|W񂠂 && @񂠂 && 摜Ȃ */
	else if (g && t && n && !e) {
		/* T[tFX_O */
		int i, j;
		
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, white);
		glBegin(GL_TRIANGLES);
		for (i = 0; i < n_t / 4; ++i) {
			for (j = 0; j < 3; ++j) {
				glNormal3fv(n + t[i * 4 + j] * 4);
				glVertex3fv(g + t[i * 4 + j] * 4);
			}
		}
		glEnd();
	}
	/* WIg񂠂 && g|W񂠂 && @Ȃ && 摜Ȃ */
	/* {vOł͂̏͋NȂ */
	else if (g && t && !n && !e) {
		/* Ct[_O */
		int i, j;
		
		glDisable(GL_LIGHTING);
		glColor4f(1.0, 1.0, 1.0, 1.0);
		for (i = 0; i < n_t / 4; ++i) {
			glBegin(GL_LINE_LOOP);
			for (j = 0; j < 3; ++j) {
				glVertex3fv(g + t[i * 4 + j] * 4);
			}
			glEnd();
		}
		glEnable(GL_LIGHTING);
	}
	/* WIg񂠂 && g|WȂ */
	else if (g && !t) {
		/* |Cg_O */
		int i;
		
		glDisable(GL_LIGHTING);
		glColor4f(1.0, 1.0, 1.0, 1.0);
		glBegin(GL_POINTS);
		for (i = 0; i < n_g / 4; ++i) {
			glVertex4fv(g + i * 4);
		}
		glEnd();
		glEnable(GL_LIGHTING);
	}
}

/* GLUT`R[obN֐ */
static void draw(void)
{
	static int first_call = TRUE;
		/* ̊֐͂߂ČĂ΂ꂽ */
	static GLint display_list = 0;
		/* fBXvCXgێ */
	
	if (first_call) {  /* ̊֐ŏɌĂ΂ꂽƂ */
		first_call = FALSE;
		display_list = glGenLists(1);
			/* fBXvCXg */
		glNewList(display_list, GL_COMPILE_AND_EXECUTE);
			draw_frame();   /* t[` */
			draw_object();  /* ̂`悷 */
		glEndList();
	}
	else {  /* ̊֐2ڈȍ~ɌĂ΂ꂽƂ */
		glCallList(display_list);
			/* fBXvCXgR[ */
	}
}

/* GLUTfBXvCR[obN֐ */
static void display_func(void)
{
#ifdef MACINTOSH
	static GLfloat v[4][4] = {
		{ 1.0, 0.0, 0.0, 0.0 },
		{ 0.0, 1.0, 0.0, 0.0 },
		{ 0.0, 0.0, -1.0, 0.0 },
		{ 0.0, 0.0, 0.0, 1.0 } };
#else
	static GLfloat v[4][4] = {
		{ 1.0, 0.0, 0.0, 0.0 },
		{ 0.0, 1.0, 0.0, 0.0 },
		{ 0.0, 0.0, 1.0, 0.0 },
		{ 0.0, 0.0, -4.0, 1.0 } };
#endif
	 
	GLfloat m[4][4];  /* W̉]s */
	int i, j;
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		/* ʃNA */
	glLoadIdentity();  /* PʍsZbg */
	glMultMatrixf(&v[0][0]);  /* _ʒuZbg */
	/*
	 * Windows/Linux/FreeBSDȂglMultMatrixf̂
	 *
	 *   gluLookAt(0.0, 0.0, 4.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
	 *
	 * ƂĂ悢
	 *
	 */
	glPushMatrix();
		create_rotation_matrix(m, &curr);
			/* NH[^jI]s𐶐 */
		glScalef(scale_factor, scale_factor, scale_factor);
			/* XP[O */
		glMultMatrixf(&m[0][0]);  /* ]sZbg */
		draw();  /* `悷 */
	glPopMatrix();
	glutSwapBuffers();  /* `obt@̓ւ */
}

/* GLUTVFCvR[obN֐ */
static void reshape_func(int w, int h)
{
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
		/* EBhETCYw */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
		/* vWFNVsɒPʍsZbg */
	gluPerspective(FOVY, (GLfloat)w/(GLfloat)h, 1.0, -100.0);
	  /* p[XyNeBuϊsZbg */
	glMatrixMode(GL_MODELVIEW);
	width = w;
	height = h;
}

/* Applicationj[֐ */
static void app_menu_func(int menu)
{
	switch (menu) {
	case APP_QUIT:
		exit(0);  /* APP_QUITj[ŃvOI */
		break;
	default:
		break;
	}
}

/* GLUTj[R[obN֐ */
static void menu_func(int dummy0)
{
	/* Ȃ */
	return;
}

/* GLUTL[{[hR[obN֐ */
static void keyboard_func(unsigned char key,
	int dummy1, int dummy2)
{
	switch (key) {
		case 'q':
		case 'Q':
		app_menu_func(APP_QUIT);
		  /* QL[ꂽAPP_QUITj[I񂾂̂Ɠ */
		break;
	default:
		break;
	}
}

/* GLUT}EXR[obN֐ */
static void mouse(int button, int state, int x, int y)
{
	if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
		/* {^hbOJn */
		begin_x = x;
		begin_y = y;
		if (glutGetModifiers() & GLUT_ACTIVE_SHIFT) { 
			/* SHIFTL[ */
			scaling = TRUE;  /* XP[OύX */
		}
		else {  /* SHIFTL[Ȃ */
			scaling = FALSE;  /* _ύX */
		}
	}
}

/* GLUT}EX[VR[obN֐ */
static void motion(int x, int y)
{
	static int count = 0;  /* ̊֐Ă΂ꂽ */
	
	if (scaling) {  /* XP[OύXȂ */
		scale_factor = scale_factor
			* (1.0 + (((float) (begin_y - y)) / height));
		begin_x = x;
		begin_y = y;
		glutPostRedisplay();  /* ĕ` */
		return;
	}
	else {
		quat t;
		
		simulate_trackball(&last, (2.0 * begin_x - width) / width,
			(height - 2.0 * begin_y) / height,
			(2.0 * x - width) / width,
			(height - 2.0 * y) / height);
			/* 
			 * EBhES0CEBhE2ɒ
			 * }EXʒusimulate_trackballɂ킽
			 * 
			 */
		begin_x = x;
		begin_y = y;
		
		/* lastcurr̃NH[^jIςcurrɑ */
		quat_mul(&t, &last, &curr);
		curr = t;
		
		if (++count % 97 == 0) {  /* ̊֐971̊... */
			GLfloat n;
			
			/* NH[^jIcurr𐳋K */
			n = quat_norm(&curr);
			quat_div_real(&curr, &curr, n);
		}
		glutPostRedisplay();  /* ĕ` */
	}
}

/* GLUTj[̏ */
static void init_glut_menu(void)
{
	int app_menu;
	
	/* Applicationj[o^ */
	app_menu = glutCreateMenu(app_menu_func);
	glutAddMenuEntry("Quit (Q)", APP_QUIT);
	
	/* j[o^ */
	glutCreateMenu(menu_func);
	glutAddSubMenu("Application", app_menu);
	
	/* j[}EXE{^ɃA^b` */
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}

/* GLUT̏ */
static void init_glut(int *argc, char **argv)
{
	glutInit(argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
		/* RGBAC_uobt@CfvXobt@w */
	glutInitWindowSize(WINDOW_SIZE, WINDOW_SIZE);
		/* EBhETCYw */
	glutInitWindowPosition(100, 100);  /* EBhEʒuw */
	glutCreateWindow(argv[0]);  /* EBhE𐶐 */
	glutKeyboardFunc(keyboard_func);
		/* L[{[hR[obN֐w */
	glutDisplayFunc(display_func);
		/* fBXvCR[obN֐w */
	glutReshapeFunc(reshape_func);
		/* VFCvR[obN֐w */
	glutMouseFunc(mouse);  /* }EXR[obN֐w */
	glutMotionFunc(motion);
		/* }EXړR[obN֐w */
	glutSetCursor(GLUT_CURSOR_RIGHT_ARROW);
		/* }EXJ[\w */
	init_glut_menu();  /* j[ */
}

/* OpenGL̏ */
static void init_gl(void)
{
#ifdef MACINTOSH
	static GLfloat light1[] = { 0.0, 0.0, -10.0, 1.0 };
#else
	static GLfloat light1[] = { 0.0, 0.0, 10.0, 1.0 };
#endif

	glClearColor(0.0, 0.0, 0.0, 1.0);  /* wiF̐ݒ */
	glEnable(GL_DEPTH_TEST);  /* fvXeXgL */
	glEnable(GL_NORMALIZE);
		/* @xNg̎KL */
	glEnable(GL_LIGHTING);  /* CeBOL */
	/* ArGg */
	glLightfv(GL_LIGHT0, GL_DIFFUSE, black);
		/* ftHg̃fBt[YItɂĂ */
	glEnable(GL_LIGHT0);
	/* FfBt[Y */
	glLightfv(GL_LIGHT1, GL_DIFFUSE, white);
	glLightfv(GL_LIGHT1, GL_POSITION, light1);
	glEnable(GL_LIGHT1);
	simulate_trackball(&curr, 0.0, 0.0, 0.0, 0.0);
		/* currNH[^jI */
}

/* help֐ */
void help(void)
{
	fputs("g: viewpoint [-gVERTICES.v [-tTRIANGLES.v]] [-eENVIRONMENT.ppm]\n", stderr);
	fputs("\tVERTICES.v\tWIgi_Wjf[^t@Ci.v`j\n", stderr);
	fputs("\tTRIANGLES.v\tg|WiOp`jf[^t@Ci.v`j\n", stderr);
	fputs("\tENVIRONMENT.ppm\t摜t@CiPPMoCi`j\n", stderr);
}

/* main֐ */
int main(int argc, char **argv) {
	init_glut(&argc, argv);
	init_gl();
	
	/* R}hC̉ */
	while (--argc) {
		++argv;
#ifdef MACINTOSH
		if (**argv == '-') {
#else
		if (**argv == '-' || **argv == '/') {
#endif
			++*argv;
			switch (**argv) {
				/* wv */
				case '?':
				case 'h':
				case 'H':
					help();
					exit(0);
					break;
				/* WIgw */
				case 'g':
					g_fn = ++*argv;
					break;
				/* g|Ww */
				case 't':
					t_fn = ++*argv;
					break;
				/* 摜w */
				case 'e':
					e_fn = ++*argv;
					break;
				default:
					break;
			}
		}
	}
	/* WIg̓ǂݍ */
	if (g_fn) {
		FILE *g_f = fopen(g_fn, "r");
		if (g_f) {
			fgetfv(&n_g, &g, g_f);
			fclose(g_f);
		}
	}
	/* g|W̓ǂݍ */
	if (t_fn) {
		FILE *t_f = fopen(t_fn, "r");
		if (t_f) {
			fgetiv(&n_t, &t, t_f);
			fclose(t_f);
		}
	}
	/* 摜̓ǂݍ݂Ɗ}bsȌ */
	if (e_fn) {
		FILE *e_f = fopen(e_fn, "r");
		if (e_f) {
			e = load_image(e_f);
			fclose(e_f);
		}
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);  /* sNZi[`̎w */
		glTexImage2D(GL_TEXTURE_2D, 0, 3, n_e_x, n_e_y, 0, GL_RGB,
			GL_UNSIGNED_BYTE, e);  /* 摜̎w */
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);  /* 摜Ë̎w */
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);  /* 摜tB^̎w */
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);  /* `@̎w */
		glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);  /* }bsOpɃeNX`W𐶐 */
		glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
		glEnable(GL_TEXTURE_GEN_S);  /* eNX`W̎L */
		glEnable(GL_TEXTURE_GEN_T);
	}
	/* WIgƃg|W񂪗^ꂽꍇ@ */
	if (g && t) {
		int i, j, k;
		
		n_n = n_g;  /* @xNǧi_Ɠj */
		n = calloc(n_n, sizeof(GLfloat));
		for (i = 0; i < n_t / 4; ++i) {
			GLfloat nn, an[3], av[3][3];
			GLint tt[3];
			
			/* Op`Ƃɖ@xNgvZ */
			for (j = 0; j < 3; ++j) {
				tt[j] = t[i * 4 + j];
				for (k = 0; k < 3; ++k) {
					av[j][k] = g[tt[j] * 4 + k];
				}
			}
			for (j = 1; j < 3; ++j) {
				for (k = 0; k < 3; ++k) {
					av[j][k] -= av[0][k];
				}
			}
			an[0] = av[1][1] * av[2][2] - av[1][2] * av[2][1];
			an[1] = av[1][2] * av[2][0] - av[1][0] * av[2][2];
			an[2] = av[1][0] * av[2][1] - av[1][1] * av[2][0];
			nn = sqrt(an[0] * an[0] + an[1] * an[1] + an[2] * an[2]);
			for (k = 0; k < 3; ++k) {
				an[k] /= nn;
			}
			/* ЂƂ̒_̎Op`ɋLĂ邱Ƃ̂łׂĂ̎Op`̊^𑫂킹 */
			for (j = 0; j < 3; ++j) {
				for (k = 0; k < 3; ++k) {
					n[tt[j] * 4 + k] += an[k];
				}
				n[tt[j] * 4 + 3] += 1.0;
			}
		}
		/* ̎Op`̊^𕽋ω */
		for (i = 0; i < n_n / 4; ++i) {
			for (j = 0; j < 3; ++j) {
				n[i * 4 + j] /= n[i * 4 + 3];
			}
		}
	}
	
	glutMainLoop();
	return 0;
}
